"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StampsPage = void 0;
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.symbol.description.js");
var _react = _interopRequireWildcard(require("react"));
var _components = require("../components");
var _svgs = require("../svgs");
var _EmptyBlock = require("../components/CoalitionBlocks/EmptyBlock");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
class StampsPage extends _react.Component {
  constructor() {
    super(...arguments);
    _defineProperty(this, "state", {
      isShown: false,
      activeCard: null
    });
    _defineProperty(this, "toggleModal", cardId => {
      this.setState({
        isShown: Boolean(cardId),
        activeCard: this.getCardDetail(cardId)
      });
      this.toggleScrollLock();
    });
    _defineProperty(this, "onClickOutside", e => this.modal && this.modal.contains(e.target) ? null : this.toggleModal());
    _defineProperty(this, "onKeyDown", e => e.keyCode === 27 ? this.toggleModal() : null);
    _defineProperty(this, "toggleScrollLock", () => document.querySelector("html").classList.toggle("modal-scroll-lock"));
    _defineProperty(this, "getCardDetail", cardId => this.props.stamps.find(stamp => stamp.id === cardId));
  }
  render() {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, !this.props.stamps || this.props.stamps.length === 0 ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
      className: "empty-block-desktop-container"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "empty-block-desktop"
    }, /*#__PURE__*/_react.default.createElement(_EmptyBlock.EmptyBlock, {
      title: "Sellos acumulados",
      description: "Próximamente con tus compras podrás llevarte productos de regalo",
      desktop: /*#__PURE__*/_react.default.createElement(_svgs.EmptyStampsPageDesktop, null),
      mobile: /*#__PURE__*/_react.default.createElement(_svgs.EmptyStampsPageMobile, null),
      svgLeft: false
    }, /*#__PURE__*/_react.default.createElement(_components.CoalitionButton, {
      label: "Ir a la p\xE1gina principal",
      style: {
        backgroundColor: "#4a90e2",
        color: "#fff",
        margin: "inherit"
      },
      onClickEvent: this.props.buttonClicked
    })))), /*#__PURE__*/_react.default.createElement("div", {
      className: "empty-block-mobile"
    }, /*#__PURE__*/_react.default.createElement(_EmptyBlock.EmptyBlockMobileView, {
      mobile: /*#__PURE__*/_react.default.createElement(_svgs.EmptyStampsPageMobile, null),
      title: "Sellos acumulados",
      description: "Próximamente con tus compras podrás llevarte productos de regalo"
    }, /*#__PURE__*/_react.default.createElement(_components.CoalitionButton, {
      label: "Ir a la p\xE1gina principal",
      style: {
        backgroundColor: "#4a90e2",
        color: "#fff",
        width: "-webkit-fill-available",
        margin: "inherit"
      },
      onClickEvent: this.props.buttonClicked
    })))) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_components.CoalitionHub, {
      title: "Sellos",
      banners: this.props.banners,
      elements: this.props.stamps
    }, this.props.stamps.map((i, k) => /*#__PURE__*/_react.default.createElement(_components.CoalitionCardStamps, {
      key: k,
      id: i.id,
      logo: i.brand_image,
      product: i.image,
      title: i.title,
      used: i.balance,
      needed: i.required_balance,
      availableToRedeem: i.available_to_redeem,
      showModal: cardId => this.toggleModal(cardId)
    }))), this.state.isShown ? /*#__PURE__*/_react.default.createElement(_components.CoalitionModal, {
      modalRef: n => this.modal = n,
      closeModal: () => this.toggleModal(),
      onKeyDown: this.onKeyDown,
      onClickOutside: this.onClickOutside,
      title: "Todo sobre tus sellos",
      footer: this.state.activeCard.valid_until
    }, /*#__PURE__*/_react.default.createElement(_components.CoalitionCardStampsDetail, {
      card: this.state.activeCard
    })) : null));
  }
}
exports.StampsPage = StampsPage;